﻿package {
	import flash.display.*;
	import flash.text.*;
	import flash.events.*;
	
	public class Hangman extends Sprite {
		private var textDisplay:TextField;
		private var phrase:String = "Imagination is more important than knowledge." // - Albert Einstein.
		private var shown:String;
		private var numWrong:int;
		
		public function Hangman() {
			// create a copy of text with _ for each letter
			shown = phrase.replace(/[A-Za-z]/g,"_");
			numWrong = 0;
			
			// set up the visible text field
			textDisplay = new TextField();
			textDisplay.defaultTextFormat = new TextFormat("Courier",30);
			textDisplay.width = 400;
			textDisplay.height = 200;
			textDisplay.wordWrap = true;
			textDisplay.selectable = false;
			textDisplay.text = shown;
			addChild(textDisplay);
			
			// listen for key presses
			stage.addEventListener(KeyboardEvent.KEY_UP,pressKey);
		}
				
		public function pressKey(event:KeyboardEvent) {
			// get letter pressed
			var charPressed:String = (String.fromCharCode(event.charCode));

			// loop through nd find matching letters
			var foundLetter:Boolean = false;
			for(var i:int=0;i<phrase.length;i++) {
				if (phrase.charAt(i).toLowerCase() == charPressed) {
					// match found, change shown phrase
					shown = shown.substr(0,i)+phrase.substr(i,1)+shown.substr(i+1);
					foundLetter = true;
				}
			}
			
			// update on-screen text
			textDisplay.text = shown;
			
			// update hangman
			if (!foundLetter) {
				numWrong++;
				character.gotoAndStop(numWrong+1);
			}
		}
	}
	
}