﻿package {
	import flash.display.*;
	import flash.text.*;
	import flash.geom.Point;
	import flash.events.*;
	import flash.utils.Timer;
	
	public class TextFly extends MovieClip {
		// constants to define animation
		static const spacing:Number = 50;
		static const phrase:String = "FlashGameU";
		static const numSteps:int = 50;
		static const stepTime:int = 20;
		static const totalRotation:Number = 360;
		static const startScale:Number = 0.0;
		static const endScale:Number = 2.0;
		static const startLoc:Point = new Point(250,0);
		static const endLoc:Point = new Point(50,100);
		private var letterFormat:TextFormat = new TextFormat("Monaco",36,0x000000,true,false,false,null,null,TextFormatAlign.CENTER);
		
		// variables to keep track of animation
		private var letters:Array = new Array();
		private var flySprite:Sprite;
		private var animTimer:Timer;
		
		public function TextFly() {
			// one sprite to hold everything
			flySprite = new Sprite();
			addChild(flySprite);
			
			// create all the of the letters as text fields inside sprites
			for(var i:int=0;i<phrase.length;i++) {
				var letter:TextField = new TextField();
				letter.defaultTextFormat = letterFormat;
				letter.embedFonts = true;
				letter.autoSize = TextFieldAutoSize.CENTER;
				letter.text = phrase.substr(i,1);
				letter.x = -letter.width/2;
				letter.y = -letter.height/2;
				var newSprite:Sprite = new Sprite();
				newSprite.addChild(letter);
				newSprite.x = startLoc.x;
				newSprite.y = startLoc.y;
				flySprite.addChild(newSprite);
				letters.push(newSprite);
			}
			
			// start animating
			animTimer = new Timer(stepTime,numSteps);
			animTimer.addEventListener(TimerEvent.TIMER,animate);
			animTimer.start();
		}
		
		public function animate(event:TimerEvent) {
			// how far along is the animation
			var percentDone:Number = event.target.currentCount/event.target.repeatCount;
			
			// change position, scale and rotation
			for(var i:int=0;i<letters.length;i++) {
				letters[i].x = startLoc.x*(1.0-percentDone) + (endLoc.x+spacing*i)*percentDone;
				letters[i].y = startLoc.y*(1.0-percentDone) + endLoc.y*percentDone;
				var scale:Number = startScale*(1-percentDone)+endScale*percentDone;
				letters[i].scaleX = scale;
				letters[i].scaleY = scale;
				letters[i].rotation = totalRotation*(percentDone-1);
			}
		}
	}
}